local speed = 10

local function update(me, dt, storer)
	me.time = me.time - dt
	if me.time < 0 then
		storer:remove(me)
	end
	if me.f then
		me:f(dt)
	else
		me.pos.y = me.pos.y - dt*speed
	end
end

local function draw(me)
	local c = me.time/me.otime - 0.5
	c = (-4*c*c + 1)*0xff
	c = c > 0 and c or 0
	love.graphics.setColor(c, c, c, 0xff)
	love.graphics.setFont(me.font)
	love.graphics.print(
		me.text, me.pos.x, me.pos.y
	)
	love.graphics.setColor(0xff, 0xff, 0xff, 0xff)
end

function newFloater(x, y, text, time, font, mvfunc)
	return setmetatable( {
		update = update,
		time = time,
		otime = time,
		draw = draw,
		font = font,
		pos = vector(x, y),
		text = text,
		f = mvfunc,
	}, {} )
end


return setmetatable({}, {__call = function(_, ...) return newFloater(...) end} )
