light = {}
local BLACK = {0, 0, 0, 0xff}
local WHITE = {0xff, 0xff, 0xff, 0xff}

function light.load()
	-- our "light"
	light.img = love.graphics.newImage(img.."light.png")
	light.state = "on"		-- other off

	-- pulse scale
	light.maxPulse = 2
	light.minPulse = 1.2
	light.currentPulse = 1.5

	-- pulsing speed and direction
	light.pulseSpeed = 0.6
	light.pulseDir = 1 			-- other -1
end

function light.draw(ch)
	-- draw "light"
	if light.state == "on" then
		local sw, sh = love.graphics.getWidth(), love.graphics.getHeight() -- screen width, height
		local hw, hh = light.img:getWidth()/2,light.img:getHeight()/2
		
		-- push to scale
		love.graphics.push()
--		love.graphics.translate(ch.pos.x+ch.shape.x, ch.pos.y+ch.shape.y)
		love.graphics.translate(ch.shape.x/2, ch.shape.y/2)
--		love.graphics.scale(light.currentPulse)
--		love.graphics.translate(-ch.pos.x-ch.shape.x, -ch.pos.y-ch.shape.y)
		love.graphics.translate(ch.pos.x-hw, ch.pos.y-hh)

		love.graphics.draw(light.img, 0, 0) --ch.pos.x-light.img:getWidth()/2+ch.shape.x, ch.pos.y-light.img:getHeight()/2+ch.shape.y)
		love.graphics.pop()
		love.graphics.setColor(BLACK)
		-- top square
		-- THIS IS SO WRONG.....
		love.graphics.rectangle("fill", 0, 0, ch.pos.x-hw+ch.shape.x, glooffs.puzzleheight)
		-- bottom square
		love.graphics.rectangle("fill", 0, 0, glooffs.puzzlewidth, ch.pos.y-hh+ch.shape.y)
		-- left square
		love.graphics.rectangle("fill", ch.pos.x+hw-ch.shape.x, ch.pos.y-hh-ch.shape.y, glooffs.puzzlewidth-ch.pos.x, glooffs.puzzleheight*2)
--		-- right square
		love.graphics.rectangle("fill", ch.pos.x-hw-ch.shape.x, ch.pos.y+hh-ch.shape.y, glooffs.puzzlewidth, glooffs.puzzleheight-ch.shape.y)
		love.graphics.setColor(WHITE)

--		love.graphics.pop()
	end
end

function light.update(dt)
	-- switch pulse directions if needed
	if light.currentPulse <= light.minPulse or
			light.currentPulse >= light.maxPulse then
		light.pulseDir = -light.pulseDir
	end

	light.currentPulse = light.currentPulse + light.pulseSpeed * light.pulseDir * dt

end
