--paths
img = "Images/"
aud = "Sounds/"
cheatx,cheaty = 486, 224

require('bitsnpieces/init')
--require('TEsound')
--require('sounder')
anim8 = require("anim8")
--sprite = require("sprite")
--movable = require("movable")
--local bump = require("bump")
runner = require("runner")
--local bump = require("bump")
local bump = love.filesystem .load("bump.lua")()
require('light')
texter = require('texter')

eps = 0.001
storager = require('store')
loader = require("AdvTiledLoader/Loader")
floater = require("floater")
bleaker = require('bleaker')
train = require('train')
spider = require('spider')
--require('slam')
--require('TEsound')
loader.path = img

glooffs = {
	trainheight = 100,
	hudwidth = 200,
	puzzlewidth = 25*32,
	puzzleheight = 16*32,
	lvl11staoffx = 1024-512,
	tunneloffx = 1024-250,
	tunnel_inoffx = 1024-400,
	parchloffy = -100,
	parchtextx = 150,
	parchtexty = 180,
	parchwidth = 600,
	cartoff = 1,
}
glooffs.puzzleoffx = (love.graphics.getWidth() - glooffs.hudwidth - glooffs.puzzlewidth) / 2
glooffs.puzzleoffy = (love.graphics.getHeight() - glooffs.trainheight - glooffs.puzzleheight) / 2
glooffs.fontoffx = 880
glooffs.fontoffy = 130
glooffs.lvldelay = 6
glooffs.chattime = 12
glooffs.defsigndelay = 5

dooroff = {
	n = {
		x = 0, y = 0, w = 0, h = -24,
	},
	s = {
		x = 0, y = 24, w = 0, h = -24,
	},
	w = {
		x = 24, y = 0, w = -24, h = 0,
	},
	e = {
		x = 0, y = 0, w = -24, h = 0,
	}
}
time = 240

gstates = {
	pic = 1,
	text = 2,
--	medium = 3,
	game = 3,
}

introstorytexttop = [[
Day 11, Year of the mystical singing mushroom crystal
]]

introstorytext = [[
I am last of my kind. Horrible news for my kind indeed, not to mention that the whole debacle isn't doing me any favors. Skunk men are a bunch of flee ridden, mangy wastes of tunnel space and their  
raids on our villages were quite common, but a full scale invasion… No one could see it coming and 
as you might of guessed from my opening statement didn't. The whole thing stunk. Heh. Any who, I barely escaped in our magical train (glad we built that).  Bad news is that no one used the train in a millennium and apparently our magic was of the materialistic nature and I am pretty sure my transport is running out of fuel. Fuel in this case are Heartstones found in abandoned mine shafts.. Thanks ancestors.. With skunk men in full pursuit and not too far behind staying alive may become really difficult in the near future. Need to hur……
]]

function clamp(val, min, max)
	return val < min and min or (val > max and max or val)
end

function inrange(val, min, max)
	return val > min and val < max
end

local function createSign(item, stor)
	if item.properties and item.properties.text then
		local tex = item.properties.text
		local tx = texter(speakerfont1, tex, item.properties.time or glooffs.defsigndelay, facetr[item.properties.face or 2], faces.SAYWHAT, item.properties.color)
		item.type = 'none'
		stor:add(tx)
		if item.properties.last then
			last = true
			local kumo = spider(10):init(true)
			stor:add(kumo)
			if lastdoor then
				lastdoor.gid = lastdoor.gid - 16
				lastdoor.type = 'door'
			end
		end
	end
end


function lvlreadyer(filename)
	if char then
	moan.kill('lvl'..char.lvlno, 2)
	end
	bump.initialize(50)
	store = storager():reset()
	map = loader.load(filename or map.properties.nextlevel)
	local spawn
	for i,v in pairs(map('daiktai').objects) do
		if v.type == 'spawn' then
			spawn = v
			v.visible = false
		end
	end
	char = runner(spawn.x, spawn.y):init('runnerinfo', map.properties.time or time)
	char.lvlno = string.sub(map.name, 14, -5)
	char.char = true

	local bl = bleaker(map.properties.name or "Hey there, adventurer", titlefont1)
	store:add(bl)
	local tr = train():init((char and char.lvlno or ''))
	char.train = tr
	if '11' == char.lvlno then
		char:winDelayer(glooffs.chattime, function(f) end,store)
		char.last = true
	end
--	train.ster = store
	store:add(tr)
	createSign(spawn, store)

	bump.add(char)
	addWalls(bump, map("path").objects )
	cartlist = {}
	addStuff(bump, map('daiktai').objects, cartlist)
	death = nil
	moan.play('lvl'..char.lvlno, true)
end
function moanloader()
	local t = {
		train = {
			filename = "Escape sirdies traukinys.ogg",
			how = "stream",
		},
		menu = {
			filename = "Escape menu.ogg",
			how = "stream",
		},
		lvl1 = {
			filename = "Escape gameplay 1.ogg",
			how = "stream",
		},
		lvl2 = {
			filename = "Escape gameplay 2.ogg",
			how = "stream",
		},
		lvl3 = {
			filename = "Escape gameplay 3.ogg",
			how = "stream",
		},
		lvl4 = {
			filename = "Escape gameplay 4.ogg",
			how = "stream",
		},
		lvl5 = {
			filename = "Escape gameplay 5.ogg",
			how = "stream",
		},
		lvl6 = {
			filename = "Escape gameplay 6.ogg",
			how = "stream",
		},
		lvl7 = {
			filename = "Escape gameplay 7.ogg",
			how = "stream",
		},
		lvl8 = {
			filename = "Paskutiniai lvl.ogg",
			how = "stream",
		},
	}
	moan.load(t, aud, false)
end


function loadfaces()
	return {
		himohimo = love.graphics.newImage(img..'veidas1.png'),
		happy = love.graphics.newImage(img..'veidas2.png'),
		whatever = love.graphics.newImage(img..'veidas3.png'),
		grin = love.graphics.newImage(img..'veidas4.png'),
		smirk = love.graphics.newImage(img..'veidas5.png'),
		unsure = love.graphics.newImage(img..'veidas6.png'),
		SAYWHAT = love.graphics.newImage(img..'veidas7.png'),
		really = love.graphics.newImage(img..'veidas8.png'),
		mushes = love.graphics.newImage(img..'veidas9.png'),
		wisp = love.graphics.newImage(img..'veidas10.png'),
		spider = love.graphics.newImage(img.."avatar_spider.png"),
	}
end

function love.load()
	bgr = love.graphics.newImage(img..'menu.png')
	tunnel = love.graphics.newImage(img..'tunnel.png')
	tunnel_in = love.graphics.newImage(img..'tunnel_in.png')
	parch = love.graphics.newImage(img..'parchment.png')
	lvl11station = love.graphics.newImage(img..'station.png')
	spider_screen = love.graphics.newImage(img..'spider_screen.png')
	HUD = love.graphics.newImage(img..'HUD.png')
	font1 = love.graphics.newFont("JollyLodger.ttf", 35)
	font2 = love.graphics.newFont("JollyLodger.ttf", 62)
	parchfont1 = love.graphics.newFont("Knight2.ttf", 18)
	speakerfont1 = love.graphics.newFont("acmesa.ttf", 14)
	titlefont1 = love.graphics.newFont("kberry.ttf", 68)
	default_font = love.graphics.newFont(14)

	faces, facetr = loadfaces()
	facetr = {
		[1] = faces.himohimo,
		[2] = faces.happy,
		[3] = faces.whatever,
		[4] = faces.grin,
		[5] = faces.smirk,
		[6] = faces.unsure,
		[7] = faces.SAYWHAT,
		[8] = faces.really,
		[9] = faces.mushes,
		[10] = faces.wisp,
		[11] = faces.spider,
	}
	moanloader()
	sounds = sounds or {}
	sounds.button = love.audio.newSource(aud..'button.wav', "static")
	sounds.cart = love.audio.newSource(aud..'cart.wav', "static")
	sounds.laugh = love.audio.newSource(aud..'laugh.wav', "static")
	sounds.step = {
			[1] = love.audio.newSource(aud..'step_gravel.wav', 'static'),
			[2] = love.audio.newSource( aud..'step_normal.wav', "static"),
			curr = 1,
		}
	sinst = {

	}
	STATE = gstates.pic
	watcher.load()
end



function love.update(dt)
	if dt > 0.1 then
		return
	end
	watcher.update(dt)
	if gstates.game == STATE then
		if cont or step then
			char:update(dt)
			bump:collide()
			step = nil
		--		light.update(dt)
			store:update(dt)
		end
		if char.lvltime < 0 then
			lvlreadyer(string.sub(map.name, 8, -5))
		end

	elseif gstates.text == STATE then 
		light.load()
		cont = true
		debug = false
		if traini and traini.intro_end then
			STATE = STATE + 1
			moan.kill("menu", 4, 1, 0)
			lvlreadyer("level 1.tmx")
		end
		store:update(dt)
	elseif gstates.pic == STATE then
		moan.play("menu", true)
	end
	moan.update(dt)
	watcher.watch(2, love.audio.getNumSources())
	watcher.watch(3, love.audio.getDistanceModel())
	watcher.watch(4, love.audio.getPosition())
	watcher.watch(5, love.audio.getVelocity())
	watcher.watch(10, love.audio.getVolume())

end

--================================================================================

function love.draw()
	if gstates.game == STATE then
		love.graphics.rectangle('line', 0, 0, love.graphics.getWidth(), glooffs.trainheight)
		love.graphics.rectangle('line', love.graphics.getWidth()-glooffs.hudwidth, 0, glooffs.hudwidth, 640)
		
		love.graphics.push()
		love.graphics.translate(glooffs.puzzleoffx, glooffs.trainheight + glooffs.puzzleoffy)
		map:draw()
		for k,v in ipairs(cartlist) do
			v:draw()
		end
		char:draw()
		store:drawsaite()
		if not last and not (debug and nolight) then
		light.draw(char)
		elseif last then
			love.graphics.setColor(0, 0, 0, 0xff)
			love.graphics.rectangle('fill', 0,0, 420, glooffs.puzzleheight)
			love.graphics.draw(spider_screen, 416, 0)
			love.graphics.setColor(0xff, 0xff, 0xff, 0xff)
		end
		if debug then
			drawWalls(map("path").objects)
		end
		store:drawlow()
		love.graphics.pop()
		love.graphics.draw(HUD, 0, 0)
		if '11' == char.lvlno then
			love.graphics.draw(lvl11station, glooffs.lvl11staoffx, 0)
		else
			love.graphics.draw(tunnel_in, glooffs.tunnel_inoffx, 0)
		end
		love.graphics.push()
		love.graphics.translate(glooffs.puzzleoffx, glooffs.trainheight + glooffs.puzzleoffy)
		store:drawhi()
		love.graphics.pop()
		if '11' ~= char.lvlno then
		end
		store:drawtop()
		if '11' ~= char.lvlno then
			love.graphics.draw(tunnel, glooffs.tunneloffx, 0)
		end
		love.graphics.setFont(font2)
		if '11' ~= char.lvlno then
			love.graphics.print(
				tostring(math.floor(char.lvltime)),
				glooffs.fontoffx, glooffs.fontoffy, 0

			)
		end
		if debug then
			love.graphics.setFont(default_font)
			love.graphics.print('DEBUG MODE', 200, 170)
			love.graphics.print('speed: ' .. char_const.speed, 200, 200)
		end

	elseif gstates.pic == STATE then
		love.graphics.draw(bgr, 0, 0)
		if debug and vol then
			love.graphics.print('volume: '..vol, 200, 230)
		end

	elseif gstates.text == STATE then
--		love.graphics.draw(parch, 0, glooffs.parchloffy)
		love.graphics.setFont(parchfont1)
		love.graphics.draw(parch, 0, 0)
		love.graphics.setColor(0,0,0,0xff)
		love.graphics.printf(introstorytexttop, glooffs.parchtextx, glooffs.parchtexty, glooffs.parchwidth)
		love.graphics.printf(introstorytext, glooffs.parchtextx, glooffs.parchtexty+32, glooffs.parchwidth)
		love.graphics.setColor(0xff,0xff,0xff,0xff)
		love.graphics.push()
		love.graphics.translate(glooffs.puzzleoffx, glooffs.trainheight + glooffs.puzzleoffy)
		store:drawhi()
		love.graphics.pop()
	end
	love.graphics.setFont(default_font)
	watcher.draw()
end


function love.keypressed(key, uni)
	watcher.toggle(key, uni)
	if 'escape' == key then
		love.event.quit()
	end
	if gstates.game == STATE then
		if 'return' == key then
			step = true
		end
		if '\\' == key then
			cont = not cont
		end
		if 'f5' == key then
			debug = not debug
		end
		if debug and 't' == key then
			char_const.speed = char_const.speed + 10
		end
		if debug and 'g' == key then
			char_const.speed = char_const.speed - 10
		end
		if debug and 'b' == key then
			nolight = not nolight
		end
		if debug and 'r' == key then
			lvlreadyer(string.sub(map.name, 8, -5))
		end
		if debug and 'f6' == key then
			lvlreadyer('level '..(char.lvlno+1)..'.tmx')
		end
		if debug and 'f7' == key then
			lvlreadyer('level '..(char.lvlno-1)..'.tmx')
		end
		char:keypressed(key, uni)
	else
		if ' ' == key or 'return' == key then
			if STATE == gstates.game then
			elseif STATE == gstates.text then
				if traini and traini.stopped then
					traini:timer(3)
				end
			else
				STATE = STATE + 1
				store = storager():reset()
				traini = train():init('intro')
				moan.kill("train", 0.2, 0, 0.5, true)
				store:add(traini)
			end
		end
	end
end

function love.keyreleased(key, uni)
--	char:keyreleased(key, uni)
end

function love.quit()
	love.event.push('q')
end

function love.mousepressed(x, y, but)
	watcher.drag(x, y, but)
	if STATE ~= gstates.game then
		if STATE == gstates.text then
			if traini and traini.stopped then
				traini:timer(3)
			end
		else
			STATE = STATE + 1
			store = storager():reset()
			traini = train():init('intro')
			moan.kill("train", 0.2, 0, 0.5, true)
			store:add(traini)
		end
	end
end
function love.mousereleased(x, y, but)
	watcher.undrag(x, y, but)
end



function drawWalls(list)
	for i,v in pairs(list) do
		love.graphics.rectangle( "line", v.x, v.y, v.width, v.height)
	end
end

function addWalls(bumper, list)
	for i,v in pairs(list) do
		v.type = 'wall'
		bumper.addStatic(v)
		v.visible = false
	end
end

function addStuff(bumper, list, clist)
	for i,v in pairs(list) do
		v.width, v.height = 32,32
		v.tipe = "tiles"
		if v.type == 'sign' then
			v.visible = false
		end
		if v.properties and v.properties.moveable then
			v.type = 'cart'
			bumper.add(v)
			table.insert(clist, v)
		else
			bumper.addStatic(v)
		end
	end
end

function bump.getBBox(item)
	if item.pos then
		return item.pos.x + item.off.x,
				item.pos.y + item.off.y,
				item.shape.x - item.off.x*2,
				item.shape.y - item.off.y*2
	else
		if item.tipe then
			if item.type == "door" then
				local prop =map.tiles[item.gid].properties['1']
				return item.x + dooroff[prop].x,
						item.y-32 + dooroff[prop].y,
						item.width + dooroff[prop].w,
						item.height + dooroff[prop].h
			elseif item.type == 'sign' then
				return item.x, item.y, item.width, item.height
			elseif item.type == 'heart' then
				return item.x + item.width/4,
						item.y + item.height/4-32,
						item.width/2,
						item.height/2
			elseif item.type == "cart" then
				return item.x + glooffs.cartoff,
						item.y + glooffs.cartoff-32,
						item.width - glooffs.cartoff*2,
						item.height - glooffs.cartoff*2
			else
				return item.x, item.y-32, item.width, item.height
			end
		else
			return item.x, item.y, item.width, item.height
		end
	end
end

local function doorSearch(it2, sto)
	if "button" == it2.type then
		it2.gid = it2.gid + 16 
	end
	it2.type = "none"
	if it2.properties.text then
		createSign(it2, sto)
	end
	for i,v in pairs(map('daiktai').objects) do
		if v.type == 'door' then
			for j,d in pairs(it2.properties) do
				if v.properties[d] then
					sounds.button:play()
					if (v.properties.number or 0) > 1 then
						v.properties.number = v.properties.number -1
						local fl = floater(v.x+10, v.y-32, v.properties.number, 1.3, font1)
						store:add(fl)
					else
						v.type = "none"
						v.gid = v.gid + 16
					end
					if v.properties.lastdoor then
						lastdoor = v
					end
				end
			end
		end
	end

end

function bump.collision(item1, item2, dx, dy)
	local it1, it2
	local rev = 1
	if item2.char then
		it1, it2 = item2, item1
		rev = -1
	else-- item1.char then
		it1, it2 = item1, item2
	end


	
	if it1.pos then
		if 'heart' == it2.type then
			it2.visible = false
			bump:remove(it2)
			it2.type = 'none'
			-- TODO STUFF OF END LVL
			createSign(it2, store)
			it1:winDelayer(glooffs.lvldelay, lvlreadyer, store)
			return
		end
		if it2.type ~= 'none' and it2.type ~= 'button' and it2.type ~= 'plate' and it2.type ~= 'sign' then
		it1.pos = it1.pos + vector(dx, dy)*rev
		end
		if it2.type == "sign" then
			createSign(it2, store)
		end

		if it2.properties and it2.properties.moveable then
			sounds.cart:play()
			local h = vector(dx/2, dy/2)
			it1.pos = it1.pos - h*rev
			it2.x = it2.x - h.x*rev
			it2.y = it2.y - h.y*rev
			it2.pushed = true
		end
		if (it2.type == 'button' and it1.action) then
			doorSearch(it2, store)
		end
	end
	if 'wall' == it2.type and not it1.char then
		it1.x = it1.x + dx
		it1.y = it1.y + dy
	end
	if "cart" == it1.type or "cart" == it2.type then
		-- TODO: attempt at box-box coll stop
		--
		if "cart" == it1.type and "cart" == it2.type then
			if it1.pushed then
				it1.x = it1.x + dx
				it1.y = it1.y + dy
				it1.pushed = false
			else
				it2.x = it2.x - dx
				it2.y = it2.y - dy
				it2.pushed = false
			end
			return
		end
		local doa, t
		if it2.type == 'door' then
			doa, t = it2, it1
		elseif it1.type == 'door' then
			doa, t = it1, it2
		end
		if doa then
			t.x = t.x + dx
			t.y = t.y + dy
		end
	end
	if it1.type == 'plate' then
		it2, it1 = it1, it2
	end
	if it2.type == "plate" and not it1.char then
		doorSearch(it2, store)
	end
end

