local STATES = {
	run = "run",
	idle = "idle",
}

local const = {
	x = 740,
	y = 200,
	endpoint = 520,
	speed = -35,
}
	


local function update(me, dt, stor)
	if me.time then
		me.time = me.time - dt
		me.pos.x = me.pos.x + dt*const.speed
		me.astate = STATES.run
		me.info[me.astate].anim:resume()
	end
	if me.pos.x > const.endpoint then
		stor:remove(me)
	end
	me.info[me.astate].anim:update(dt)
end

local function special_update(me, dt, stor)
	local pro
	if me.time then
		me.time = me.time - dt
		pro = (me.pos.x - const.endpoint) / (const.x - const.endpoint)
		if pro > 0.15 then
			me.pos.x = me.pos.x + dt*const.speed*pro
			me.astate = STATES.run
			me.info[me.astate].anim:resume()
		else
			me.astate = STATES.idle
			me.info[me.astate].anim:resume()
		end
	end
	if me.pos.x < const.endpoint then
		stor:remove(me)
	end
	if pro > 0.05 then
		me.info[me.astate].anim:update(dt)
	end
end

local function draw(me)
	me.info[me.astate].anim:draw(me.images[me.astate], me.pos.x, me.pos.y)
end

local function setTime(me, time)
	me.time = time
	me.otime = time
end



local function init(me, special)
	me.update = special and special_update or me.update
	me.images = {}
	me.drawsaite = true
	me.info = love.filesystem.load( "spiderinfo"..'.lua')()
	for k,v in pairs(me.info) do
		local i = love.graphics.newImage(img..v.filename)
		me.images[k] = i
		local g = anim8.newGrid(v.dim.x, v.dim.y, i:getWidth(), i:getHeight())
		me.info[k].grid = g
		me.info[k].anim = anim8.newAnimation(v.tipe, g(v.frames), v.delay, v.delays)
		me.info[k].anim:pause()
	end
	me.astate = STATES.idle
	me.info[me.astate].anim:resume()
	return me
end
	

function newSpider(time)
	return setmetatable( {
		pos = vector(const.x, const.y),
		init = init,
		timer = setTime,
		update = update,
		draw = draw,
		time = time,
		otime = time,
	}, {} )
end


return setmetatable({}, {__call = function(_, ...) return newSpider(...) end} )
		
