
local function add(me, what)
	me.id = me.id + 1
	me.objects[me.id] = what
	what.store_id = me.id
end


local function update(me, dt)
	for k,v in pairs(me.objects) do
		v:update(dt, me)
	end
	if me.replace then
		me.replace = nil
		me.objects = me.new
		me.new = nil
	end
end

local function drawsaite(me)
	for k,v in pairs(me.objects) do
		if v.drawsaite then
			v:draw()
		end
	end
end

local function drawlow(me)
	for k,v in pairs(me.objects) do
		if not v.drawsaite and not v.drawhi and not v.drawtop then
			v:draw()
		end
	end
end

local function drawhi(me)
	for k,v in pairs(me.objects) do
		if v.drawhi then
			v:draw()
		end
	end
end

local function drawtop(me)
	for k,v in pairs(me.objects) do
		if v.drawtop then
			v:draw()
		end
	end
end

local function remove(me, what)
	me.new = {}
	for i,v in pairs(me.objects) do
		if v.store_id ~= what.store_id then
			me.new[v.store_id] = v
		end
	end
	me.replace = true
end

local function reset(me)
	me.id = 1
	me.objects = {}
	return me
end

function newStore()
	return setmetatable({
		id = 1,
		add = add,
		update = update,
		remove = remove,
		drawlow = drawlow,
		drawhi = drawhi,
		drawtop = drawtop,
		drawsaite = drawsaite,
		reset = reset,
		objects = {},
	}, {} )
end

return setmetatable({}, {__call = function(_, ...) return  newStore(...) end} )
