local const = {
	facex = 860,
	facey = 480,
	textx = 830,
	texty = 400,
	textw = 160,
	lefttime = 1,
}

local colors = {
	["green"] = {0x55, 0xf5, 0x22, 0xff},
	["red"] = {0xf7, 0x22, 0x55, 0xff},
}
local texactive = nil

local function update(me, dt, storer)
	me.time = me.time - dt
	if me.time < 0 then
		storer:remove(me)
	end
end

local function draw(me)
	-- set font
	if texactive == me then
	love.graphics.setFont(me.font)
	love.graphics.draw(me.face, const.facex, const.facey)
	if colors[me.color] then
		love.graphics.setColor(colors[me.color])
	end
	love.graphics.printf(me.text, const.textx, const.texty, const.textw, 'center')
	love.graphics.setColor(0xff, 0xff, 0xff, 0xff)
	end
end

function newTexter(font, text, time, face, faceend, color)
	return setmetatable( {
		font = font,
		faceend = faceend,
		face = face,
		time = time,
		update = update,
		text = text,
		draw = draw,
		drawtop = true,
		color = color,
	}, {} )
end

return setmetatable({}, {__call = function(_, ...) t =  newTexter(...); texactive = t; return t end} )
